"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports["default"] = sliceAnsi;

var _isFullwidthCodePoint = _interopRequireDefault(require("is-fullwidth-code-point"));

var _ansiStyles = _interopRequireDefault(require("ansi-styles"));

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { "default": obj }; }

function _slicedToArray(arr, i) { return _arrayWithHoles(arr) || _iterableToArrayLimit(arr, i) || _unsupportedIterableToArray(arr, i) || _nonIterableRest(); }

function _nonIterableRest() { throw new TypeError("Invalid attempt to destructure non-iterable instance.\nIn order to be iterable, non-array objects must have a [Symbol.iterator]() method."); }

function _iterableToArrayLimit(arr, i) { if (typeof Symbol === "undefined" || !(Symbol.iterator in Object(arr))) return; var _arr = []; var _n = true; var _d = false; var _e = undefined; try { for (var _i = arr[Symbol.iterator](), _s; !(_n = (_s = _i.next()).done); _n = true) { _arr.push(_s.value); if (i && _arr.length === i) break; } } catch (err) { _d = true; _e = err; } finally { try { if (!_n && _i["return"] != null) _i["return"](); } finally { if (_d) throw _e; } } return _arr; }

function _arrayWithHoles(arr) { if (Array.isArray(arr)) return arr; }

function _createForOfIteratorHelper(o, allowArrayLike) { var it; if (typeof Symbol === "undefined" || o[Symbol.iterator] == null) { if (Array.isArray(o) || (it = _unsupportedIterableToArray(o)) || allowArrayLike && o && typeof o.length === "number") { if (it) o = it; var i = 0; var F = function F() {}; return { s: F, n: function n() { if (i >= o.length) return { done: true }; return { done: false, value: o[i++] }; }, e: function e(_e2) { throw _e2; }, f: F }; } throw new TypeError("Invalid attempt to iterate non-iterable instance.\nIn order to be iterable, non-array objects must have a [Symbol.iterator]() method."); } var normalCompletion = true, didErr = false, err; return { s: function s() { it = o[Symbol.iterator](); }, n: function n() { var step = it.next(); normalCompletion = step.done; return step; }, e: function e(_e3) { didErr = true; err = _e3; }, f: function f() { try { if (!normalCompletion && it["return"] != null) it["return"](); } finally { if (didErr) throw err; } } }; }

function _toConsumableArray(arr) { return _arrayWithoutHoles(arr) || _iterableToArray(arr) || _unsupportedIterableToArray(arr) || _nonIterableSpread(); }

function _nonIterableSpread() { throw new TypeError("Invalid attempt to spread non-iterable instance.\nIn order to be iterable, non-array objects must have a [Symbol.iterator]() method."); }

function _unsupportedIterableToArray(o, minLen) { if (!o) return; if (typeof o === "string") return _arrayLikeToArray(o, minLen); var n = Object.prototype.toString.call(o).slice(8, -1); if (n === "Object" && o.constructor) n = o.constructor.name; if (n === "Map" || n === "Set") return Array.from(o); if (n === "Arguments" || /^(?:Ui|I)nt(?:8|16|32)(?:Clamped)?Array$/.test(n)) return _arrayLikeToArray(o, minLen); }

function _iterableToArray(iter) { if (typeof Symbol !== "undefined" && Symbol.iterator in Object(iter)) return Array.from(iter); }

function _arrayWithoutHoles(arr) { if (Array.isArray(arr)) return _arrayLikeToArray(arr); }

function _arrayLikeToArray(arr, len) { if (len == null || len > arr.length) len = arr.length; for (var i = 0, arr2 = new Array(len); i < len; i++) { arr2[i] = arr[i]; } return arr2; }

var astralRegex = /^[\uD800-\uDBFF][\uDC00-\uDFFF]$/;
var ESCAPES = ["\x1B", "\x9B"];

var wrapAnsi = function wrapAnsi(code) {
  return "".concat(ESCAPES[0], "[").concat(code, "m");
};

var checkAnsi = function checkAnsi(ansiCodes, isEscapes, endAnsiCode) {
  var output = [];
  ansiCodes = _toConsumableArray(ansiCodes);

  var _iterator = _createForOfIteratorHelper(ansiCodes),
      _step;

  try {
    for (_iterator.s(); !(_step = _iterator.n()).done;) {
      var ansiCode = _step.value;
      var ansiCodeOrigin = ansiCode;

      if (ansiCode.includes(';')) {
        ansiCode = ansiCode.split(';')[0][0] + '0';
      }

      var item = _ansiStyles["default"].codes.get(Number.parseInt(ansiCode, 10));

      if (item) {
        var indexEscape = ansiCodes.indexOf(item.toString());

        if (indexEscape === -1) {
          output.push(wrapAnsi(isEscapes ? item : ansiCodeOrigin));
        } else {
          ansiCodes.splice(indexEscape, 1);
        }
      } else if (isEscapes) {
        output.push(wrapAnsi(0));
        break;
      } else {
        output.push(wrapAnsi(ansiCodeOrigin));
      }
    }
  } catch (err) {
    _iterator.e(err);
  } finally {
    _iterator.f();
  }

  if (isEscapes) {
    output = output.filter(function (element, index) {
      return output.indexOf(element) === index;
    });

    if (endAnsiCode !== undefined) {
      var fistEscapeCode = wrapAnsi(_ansiStyles["default"].codes.get(Number.parseInt(endAnsiCode, 10))); // TODO: Remove the use of `.reduce` here.
      // eslint-disable-next-line unicorn/no-array-reduce

      output = output.reduce(function (current, next) {
        return next === fistEscapeCode ? [next].concat(_toConsumableArray(current)) : [].concat(_toConsumableArray(current), [next]);
      }, []);
    }
  }

  return output.join('');
};

function sliceAnsi(string, begin, end) {
  var characters = _toConsumableArray(string);

  var ansiCodes = [];
  var stringEnd = typeof end === 'number' ? end : characters.length;
  var isInsideEscape = false;
  var ansiCode;
  var visible = 0;
  var output = '';

  var _iterator2 = _createForOfIteratorHelper(characters.entries()),
      _step2;

  try {
    for (_iterator2.s(); !(_step2 = _iterator2.n()).done;) {
      var _step2$value = _slicedToArray(_step2.value, 2),
          index = _step2$value[0],
          character = _step2$value[1];

      var leftEscape = false;

      if (ESCAPES.includes(character)) {
        var code = /\d[^m]*/.exec(string.slice(index, index + 18));
        ansiCode = code && code.length > 0 ? code[0] : undefined;

        if (visible < stringEnd) {
          isInsideEscape = true;

          if (ansiCode !== undefined) {
            ansiCodes.push(ansiCode);
          }
        }
      } else if (isInsideEscape && character === 'm') {
        isInsideEscape = false;
        leftEscape = true;
      }

      if (!isInsideEscape && !leftEscape) {
        visible++;
      }

      if (!astralRegex.test(character) && (0, _isFullwidthCodePoint["default"])(character.codePointAt())) {
        visible++;

        if (typeof end !== 'number') {
          stringEnd++;
        }
      }

      if (visible > begin && visible <= stringEnd) {
        output += character;
      } else if (visible === begin && !isInsideEscape && ansiCode !== undefined) {
        output = checkAnsi(ansiCodes);
      } else if (visible >= stringEnd) {
        output += checkAnsi(ansiCodes, true, ansiCode);
        break;
      }
    }
  } catch (err) {
    _iterator2.e(err);
  } finally {
    _iterator2.f();
  }

  return output;
}
